// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tts_interfaces:srv/Synthesizer.idl
// generated code does not contain a copyright notice

#ifndef TTS_INTERFACES__SRV__SYNTHESIZER__STRUCT_HPP_
#define TTS_INTERFACES__SRV__SYNTHESIZER__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__tts_interfaces__srv__Synthesizer_Request __attribute__((deprecated))
#else
# define DEPRECATED__tts_interfaces__srv__Synthesizer_Request __declspec(deprecated)
#endif

namespace tts_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct Synthesizer_Request_
{
  using Type = Synthesizer_Request_<ContainerAllocator>;

  explicit Synthesizer_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->text = "";
      this->metadata = "";
    }
  }

  explicit Synthesizer_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : text(_alloc),
    metadata(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->text = "";
      this->metadata = "";
    }
  }

  // field types and members
  using _text_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _text_type text;
  using _metadata_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _metadata_type metadata;

  // setters for named parameter idiom
  Type & set__text(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->text = _arg;
    return *this;
  }
  Type & set__metadata(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->metadata = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tts_interfaces::srv::Synthesizer_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const tts_interfaces::srv::Synthesizer_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tts_interfaces::srv::Synthesizer_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tts_interfaces::srv::Synthesizer_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tts_interfaces::srv::Synthesizer_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tts_interfaces::srv::Synthesizer_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tts_interfaces::srv::Synthesizer_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tts_interfaces::srv::Synthesizer_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tts_interfaces::srv::Synthesizer_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tts_interfaces::srv::Synthesizer_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tts_interfaces__srv__Synthesizer_Request
    std::shared_ptr<tts_interfaces::srv::Synthesizer_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tts_interfaces__srv__Synthesizer_Request
    std::shared_ptr<tts_interfaces::srv::Synthesizer_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Synthesizer_Request_ & other) const
  {
    if (this->text != other.text) {
      return false;
    }
    if (this->metadata != other.metadata) {
      return false;
    }
    return true;
  }
  bool operator!=(const Synthesizer_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Synthesizer_Request_

// alias to use template instance with default allocator
using Synthesizer_Request =
  tts_interfaces::srv::Synthesizer_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace tts_interfaces

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__tts_interfaces__srv__Synthesizer_Response __attribute__((deprecated))
#else
# define DEPRECATED__tts_interfaces__srv__Synthesizer_Response __declspec(deprecated)
#endif

namespace tts_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct Synthesizer_Response_
{
  using Type = Synthesizer_Response_<ContainerAllocator>;

  explicit Synthesizer_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->result = "";
    }
  }

  explicit Synthesizer_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : result(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->result = "";
    }
  }

  // field types and members
  using _result_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _result_type result;

  // setters for named parameter idiom
  Type & set__result(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tts_interfaces::srv::Synthesizer_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const tts_interfaces::srv::Synthesizer_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tts_interfaces::srv::Synthesizer_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tts_interfaces::srv::Synthesizer_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tts_interfaces::srv::Synthesizer_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tts_interfaces::srv::Synthesizer_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tts_interfaces::srv::Synthesizer_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tts_interfaces::srv::Synthesizer_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tts_interfaces::srv::Synthesizer_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tts_interfaces::srv::Synthesizer_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tts_interfaces__srv__Synthesizer_Response
    std::shared_ptr<tts_interfaces::srv::Synthesizer_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tts_interfaces__srv__Synthesizer_Response
    std::shared_ptr<tts_interfaces::srv::Synthesizer_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Synthesizer_Response_ & other) const
  {
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const Synthesizer_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Synthesizer_Response_

// alias to use template instance with default allocator
using Synthesizer_Response =
  tts_interfaces::srv::Synthesizer_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace tts_interfaces

namespace tts_interfaces
{

namespace srv
{

struct Synthesizer
{
  using Request = tts_interfaces::srv::Synthesizer_Request;
  using Response = tts_interfaces::srv::Synthesizer_Response;
};

}  // namespace srv

}  // namespace tts_interfaces

#endif  // TTS_INTERFACES__SRV__SYNTHESIZER__STRUCT_HPP_
